SystemOrganization addCategory: #'RefEx-Base'!
SystemOrganization addCategory: #'RefEx-Base-Tests'!
SystemOrganization addCategory: #'RefEx-Browser'!
SystemOrganization addCategory: #'RefEx-Browser-Commands'!
SystemOrganization addCategory: #'RefEx-Browser-Filters'!
SystemOrganization addCategory: #'RefEx-Browser-Nodes'!

OBFilter subclass: #OBRefExIconFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Browser-Filters'!

!OBRefExIconFilter commentStamp: 'rkrk 9/20/2007 15:28' prior: 0!
Determines the icons for a RefExChangeNode.!

!OBRefExIconFilter methodsFor: 'as yet unclassified' stamp: 'rkrk 9/24/2007 23:56'!
icon: aSymbol forNode: aNode

	^ aNode isLoaded
		ifTrue: [#changeSetInstalled]
		ifFalse: [#changeSetNotInstalled]! !

OrderedCollection subclass: #RefExTopicCollection
	instanceVariableNames: 'name refactorings'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'RefEx-Base'!

!RefExTopicCollection class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/27/2007 02:54'!
default

	Default ifNil: [self default: self new].
	^ Default! !

!RefExTopicCollection class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/27/2007 02:55'!
default: instanceOfRefExTopicCollection

	Default := instanceOfRefExTopicCollection! !

!RefExTopicCollection methodsFor: 'adding' stamp: 'rkrk 10/15/2007 20:13'!
addTopicNamed: nameString withDescription: descriptionString 

	| topic |
	topic := RefExTopic named: nameString.
	topic description: descriptionString.
	self add: topic.! !

!RefExTopicCollection methodsFor: 'finding' stamp: 'rkrk 10/15/2007 23:20'!
findRefactoringNamed: refactoringName
	
	self do: [:each | (each findRefactoringNamed: refactoringName)
			ifNotNilDo: [:refactoring | ^ refactoring] ].
	^ nil! !

!RefExTopicCollection methodsFor: 'finding' stamp: 'rkrk 10/15/2007 22:41'!
findTopicNamed: topicName 
	
	| newTopic |
	^ self 
		detect: [:each | each name = topicName] 
		ifNone: [
			newTopic := RefExTopic named: topicName.
			self add: newTopic.
			newTopic.]! !

!RefExTopicCollection methodsFor: 'adding' stamp: 'rkrk 10/15/2007 23:11'!
inRefactoringNamed: refactoringName addChangeNamed: changeName withChangeFileName: changeFileName

	| refactoring |
	refactoring := self findRefactoringNamed: refactoringName.
	refactoring ifNil: [^ self].
	refactoring 
		addChangeNamed: changeName  
		withChangeFileName: changeFileName ! !

!RefExTopicCollection methodsFor: 'adding' stamp: 'rkrk 10/15/2007 23:34'!
inRefactoringNamed: refactoringName letChangeNamed: changeName1 dependOnChangeNamed: changeName2

	| refactoring |
	refactoring := self findRefactoringNamed: refactoringName.
	refactoring ifNil: [^ self].
	refactoring 
		changeNamed: changeName1 
		dependsOnChangeNamed: changeName2.! !

!RefExTopicCollection methodsFor: 'adding' stamp: 'rkrk 10/15/2007 22:37'!
inTopicNamed: topicName addRefactoringNamed: refactoringName withDescription: refactoringDescription

	| topic refactoring |
	topic := self findTopicNamed: topicName.
	refactoring := RefExRefactoring 
		named: refactoringName
		withDescription: refactoringDescription.

	topic addRefactoring: refactoring! !

!OBMorphicIcons methodsFor: '*RefEx' stamp: 'rkrk 9/20/2007 16:43'!
changeSetInstalled

	^  (Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 470629383 1678588935 168639495 0 0 0 0 0 0 0 0 0 0 0 0 638401543 3926735879 4279191048 2332834822 0 0 0 0 0 0 0 0 0 0 0 286080007 3658300423 4279656203 4280588565 2634824710 0 0 0 0 0 0 0 0 0 0 67976199 3171761159 4279522826 4280920855 4279723533 940391431 0 1057831943 2601335815 1393376263 0 0 0 0 0 0 2551004167 4279257097 4280787990 4280522260 3339467782 0 1426930695 4228858632 4279656972 4044309768 353188871 0 0 0 0 1846361095 4279058183 4280522516 4280921112 4279390986 1443707911 0 3138206727 4280720150 4280987416 4280123152 1779252231 0 0 0 1208826887 4228725767 4280189969 4280987416 4279922702 3725409287 51198983 0 3792518663 4290175920 4288206991 4280921112 3557904394 0 17644551 1879915527 4144839687 4279856397 4280987416 4280388114 4262280199 1091386375 0 0 2970434567 4282753848 4284006474 4280987416 4280255761 2366454791 3171761159 4279057415 4279789581 4280921112 4280655637 4279124487 2383232007 0 0 0 1930247175 4279657228 4280987416 4280987416 4280921112 4279257865 4279057415 4279989519 4280987416 4280920855 4279390217 3524082695 118307847 0 0 0 487406599 4161617415 4280788246 4280987416 4280987416 4280654869 4280588821 4280987416 4280986904 4279656972 3758963719 470629383 0 0 0 0 0 2467118087 4280055824 4280921111 4280987416 4280987416 4280921111 4280987160 4279723020 3893181447 604847111 0 0 0 0 0 0 420297735 3993911815 4280456978 4280456467 4280456722 4280523027 4279723533 3993844743 772619271 0 0 0 0 0 0 0 0 1192049671 4262680842 4280589588 4280522004 4279523851 3859627015 957168647 0 0 0 0 0 0 0 0 0 0 1393376263 3658499848 3507305990 2131573767 202193927 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!OBMorphicIcons methodsFor: '*RefEx' stamp: 'rkrk 9/20/2007 16:51'!
changeSetNotInstalled

	 ^ (Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 456065024 522780672 0 0 0 0 0 0 237240320 372113408 0 0 0 0 0 1579876352 4202104576 4184802816 1160511488 0 0 0 0 640614400 3915842816 4235724544 1831600128 0 0 0 338034688 4201645824 4294656559 4294030242 4185591816 1093337088 0 0 774635520 4017425669 4294026130 4294594877 4269344768 791347200 0 0 438763520 4133618944 4294513664 4294217597 4293965991 4168355077 1043136512 908787712 4101574149 4293964192 4294093722 4294711556 4268164608 841875456 0 0 0 1059913728 4167828992 4294579456 4294155145 4293963678 4151183619 4152299270 4293964964 4294092951 4294645763 4268623616 1579876352 0 0 0 0 0 1110114304 4184803072 4294645249 4294092180 4293961365 4293965734 4294091923 4294579970 4251715072 1512898560 0 0 0 0 0 0 0 1160511488 4201711360 4294776835 4294218626 4294282106 4294514178 4234806784 1445724160 0 0 0 0 0 0 0 0 1244463104 4220389888 4294907136 4293856768 4293922560 4294448128 4150658560 942538752 0 0 0 0 0 0 0 1294663680 4237625856 4294907136 4293397504 4292019200 4291953408 4293725696 4294382592 4099933440 841875456 0 0 0 0 0 1361838080 4254731008 4294907136 4293397504 4291953664 4150068224 4253812480 4291953408 4293856768 4294185984 4032693504 741212160 0 0 0 992673792 4254927616 4294907136 4293397504 4292019200 4133094400 1009451008 1495990272 4270983168 4291953408 4293988096 4294054912 3964994560 171114496 0 0 1277952000 4291301120 4293594368 4292019200 4132897792 1009451008 0 0 1630339072 4271376640 4291953408 4294185216 4269213440 338034688 0 0 0 2639266560 4289596416 4115989248 1009451008 0 0 0 0 1781202944 4287301632 4288022784 2385444864 0 0 0 0 0 1026424832 774635520 0 0 0 0 0 0 808124416 841875456 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

Object subclass: #OBRefExDiffCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Browser-Commands'!

!OBRefExDiffCommand commentStamp: 'rkrk 9/24/2007 21:40' prior: 0!
Not used yet!

!OBRefExDiffCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 21:12'!
execute! !

!OBRefExDiffCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 21:09'!
isAButtonOnly
	^ true! !

!OBRefExDiffCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 21:11'!
isActive
	^ target isKindOf: OBRefExChangesNode! !

!OBRefExDiffCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 21:08'!
label
	^ 'show diffs'! !

!OBRefExDiffCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 21:08'!
wantsButton
	^ true! !

Object subclass: #RefExChangeSetLoader
	instanceVariableNames: 'streamType service fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Base'!

!RefExChangeSetLoader commentStamp: 'rkrk 9/24/2007 01:36' prior: 0!
Is associated with a filename of a changeSet. Loads it into the system when asked. Can give it also away (e.g. to the FileContentsBrowser).!

!RefExChangeSetLoader class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/24/2007 00:22'!
defaultForFileNamed: aFileName

	"instantiate with FileStream and some service for filingIn"
	^ self for: aFileName withStreamType: FileStream andService: ChangeSet serviceFileIntoNewChangeSet
! !

!RefExChangeSetLoader class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/19/2007 02:13'!
for: aFileName withStreamType: aStreamClass andService: serviceWhichLoadsChangeSetFromStream

	^ (self withStreamType: aStreamClass andService: serviceWhichLoadsChangeSetFromStream)
		fileName: aFileName;
		yourself.! !

!RefExChangeSetLoader class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/18/2007 23:24'!
withStreamType: aStreamClass andService: serviceWhichLoadsChangeSetFromStream

	^ self new 
		streamType: aStreamClass;
		useService: serviceWhichLoadsChangeSetFromStream;
		yourself.! !

!RefExChangeSetLoader methodsFor: 'private' stamp: 'rkrk 9/24/2007 21:17'!
assureThatFileExists

	(streamType isAFileNamed: self fileName) 
		ifFalse: [self error: 'Attempting to load a non-existing changeSet!!'].! !

!RefExChangeSetLoader methodsFor: 'naming' stamp: 'rkrk 9/19/2007 03:12'!
changeSetNameFromFileName
	"Remove the last the substring after the last but one dot in the filename"
	| result indexOfLastDot |
	result := self fileName.
	2 timesRepeat: 
		[indexOfLastDot := result findLastOccuranceOfString: '.' startingAt: 0.
		result := result first: indexOfLastDot - 1.].
	^ result! !

!RefExChangeSetLoader methodsFor: 'accessing' stamp: 'rkrk 9/19/2007 02:12'!
fileName

	^ fileName! !

!RefExChangeSetLoader methodsFor: 'accessing' stamp: 'rkrk 9/19/2007 02:12'!
fileName: aFileName

	fileName := aFileName ! !

!RefExChangeSetLoader methodsFor: 'testing' stamp: 'rkrk 9/19/2007 03:14'!
isLoaded

	^ (ChangeSet named: self changeSetNameFromFileName) notNil! !

!RefExChangeSetLoader methodsFor: 'loading' stamp: 'rkrk 9/20/2007 03:43'!
loadChangeSet

	self isLoaded ifTrue: [^self].
	self
		assureThatFileExists;
		loadChangeSetIntoSystem.! !

!RefExChangeSetLoader methodsFor: 'private' stamp: 'rkrk 9/20/2007 02:33'!
loadChangeSetIntoSystem

	streamType fileNamed: self fileName
				do: [:stream | service performServiceFor: stream].! !

!RefExChangeSetLoader methodsFor: 'accessing' stamp: 'rkrk 9/18/2007 23:35'!
streamType: aStreamClass

	streamType := aStreamClass.! !

!RefExChangeSetLoader methodsFor: 'testing' stamp: 'rkrk 9/25/2007 00:33'!
unload
	| changeSet |
	self flag: #TODO.
	changeSet := ChangeSet named: self changeSetNameFromFileName.
	"self halt."
	changeSet ifNil: [^self].
	changeSet changedClasses select: [:each | each isMeta not]
							thenDo: [:each | each removeFromSystem.].
	
	Smalltalk garbageCollect.
"SmalltalkImage current fixObsoleteReferences."

	ChangeSorter removeChangeSet: changeSet.
	
Smalltalk garbageCollect.
"SmalltalkImage current fixObsoleteReferences."! !

!RefExChangeSetLoader methodsFor: 'accessing' stamp: 'rkrk 9/18/2007 23:35'!
useService: serviceWhichLoadsChangeSetFromStream

	service := serviceWhichLoadsChangeSetFromStream! !

Object subclass: #RefExEntry
	instanceVariableNames: 'name description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Base'!

RefExEntry subclass: #RefExChange
	instanceVariableNames: 'basedOnChanges changeSetProxy changeDependents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Base'!

!RefExChange commentStamp: 'rkrk 9/24/2007 23:34' prior: 0!
RefExChange bieten das Interface zum Laden von Refactoring ChangeSets. Sie realisieren dabei die Abhngigkeiten zwischen ChangSets.!

!RefExChange methodsFor: 'accessing' stamp: 'rkrk 9/25/2007 00:21'!
addAsDependent: aRefExChange

	self changeDependents add: aRefExChange! !

!RefExChange methodsFor: 'adding' stamp: 'rkrk 10/15/2007 23:08'!
addChangeFileNamed: fileName

	| newProxy |
	newProxy := RefExChangeSetLoader defaultForFileNamed: fileName.
	self changeSetProxy: newProxy.! !

!RefExChange methodsFor: 'accessing' stamp: 'rkrk 9/19/2007 01:58'!
basedOnChanges
	^ basedOnChanges! !

!RefExChange methodsFor: 'accessing' stamp: 'rkrk 9/19/2007 01:58'!
basedOnChanges: anObject
	basedOnChanges := anObject! !

!RefExChange methodsFor: 'accessing' stamp: 'rkrk 9/25/2007 00:20'!
changeDependents

	^ changeDependents! !

!RefExChange methodsFor: 'accessing' stamp: 'rkrk 9/24/2007 01:42'!
changeSetFileName
	^ self changeSetProxy fileName! !

!RefExChange methodsFor: 'accessing' stamp: 'rkrk 9/21/2007 14:49'!
changeSetProxy
	^ changeSetProxy! !

!RefExChange methodsFor: 'accessing' stamp: 'rkrk 9/21/2007 14:50'!
changeSetProxy: anObject
	changeSetProxy := anObject! !

!RefExChange methodsFor: 'accessing' stamp: 'rkrk 9/25/2007 00:12'!
dependsOn: aRefExChange

	basedOnChanges add: aRefExChange.
	aRefExChange addAsDependent: self.! !

!RefExChange methodsFor: 'initialization' stamp: 'rkrk 9/25/2007 00:22'!
initialize
	super initialize.
	self name: 'Unnamed change'.
	
	basedOnChanges := OrderedCollection new.
	changeDependents := OrderedCollection new.! !

!RefExChange methodsFor: 'testing' stamp: 'rkrk 9/24/2007 23:57'!
isLoaded

	^ self changeSetProxy isLoaded ! !

!RefExChange methodsFor: 'loading' stamp: 'rkrk 9/25/2007 00:41'!
loadBasedOnChanges

	self basedOnChanges select: [:each | each isLoaded not]
						thenDo: [:each | each loadChanges].! !

!RefExChange methodsFor: 'loading' stamp: 'rkrk 9/19/2007 03:17'!
loadChanges

	self
		loadBasedOnChanges;
		loadOwnChanges.! !

!RefExChange methodsFor: 'loading' stamp: 'rkrk 9/21/2007 14:53'!
loadOwnChanges

	self changeSetProxy ifNotNilDo: [:cs | cs loadChangeSet].! !

!RefExChange methodsFor: 'loading' stamp: 'rkrk 9/25/2007 10:27'!
reloadBasedOn

	"self halt."
	self basedOnChanges do: [:each | each reloadChanges ]! !

!RefExChange methodsFor: 'loading' stamp: 'rkrk 9/25/2007 10:27'!
reloadChanges

	self
		reloadBasedOn;
		unloadChanges;
		loadChanges.
		! !

!RefExChange methodsFor: 'unloading' stamp: 'rkrk 9/24/2007 02:50'!
unloadBasedOnChanges

	self basedOnChanges do: [:each | each unloadChanges].! !

!RefExChange methodsFor: 'unloading' stamp: 'rkrk 9/25/2007 09:15'!
unloadChanges

	self 
		unloadDependents;
		unloadOwnChanges";
		reloadBasedOn."! !

!RefExChange methodsFor: 'unloading' stamp: 'rkrk 9/25/2007 10:06'!
unloadChangesAndRestoreBasedOn

	self 
		unloadChanges;
		reloadBasedOn.! !

!RefExChange methodsFor: 'unloading' stamp: 'rkrk 9/25/2007 00:38'!
unloadDependents
		
	self changeDependents select: [:each | each isLoaded]
	 					thenDo: [:each | each unloadChanges]! !

!RefExChange methodsFor: 'unloading' stamp: 'rkrk 9/25/2007 00:31'!
unloadOwnChanges

	self changeSetProxy ifNotNilDo: [:obj | obj unload].! !

!RefExEntry class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 02:25'!
named: aName

	^ self new name: aName! !

!RefExEntry class methodsFor: 'as yet unclassified' stamp: 'rkrk 10/15/2007 21:35'!
named: aName withDescription: aDescription

	^ self new 
		name: aName;
		description: aDescription;
		yourself! !

!RefExEntry methodsFor: 'accessing' stamp: 'rkrk 9/20/2007 04:07'!
= other

	self == other ifTrue: [^ true].
	self class = other class ifFalse: [^ false].
	^ self name = other name and: [self description = other description]! !

!RefExEntry methodsFor: 'accessing' stamp: 'rkrk 9/20/2007 02:28'!
description
	^ description! !

!RefExEntry methodsFor: 'accessing' stamp: 'rkrk 9/20/2007 02:28'!
description: anObject
	description := anObject! !

!RefExEntry methodsFor: 'accessing' stamp: 'rkrk 9/20/2007 02:40'!
hash
	^ self name hash + self description hash! !

!RefExEntry methodsFor: 'accessing' stamp: 'rkrk 9/20/2007 02:25'!
name
	^ name! !

!RefExEntry methodsFor: 'accessing' stamp: 'rkrk 9/20/2007 02:25'!
name: anObject
	name := anObject! !

RefExEntry subclass: #RefExRefactoring
	instanceVariableNames: 'changeSets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Base'!

!RefExRefactoring methodsFor: 'adding' stamp: 'rkrk 10/15/2007 23:07'!
addChangeNamed: changeName withChangeFileName: changeFileName 
	
	| newChange |
	newChange := RefExChange named: changeName.
	newChange addChangeFileNamed: changeFileName.
	self changeSets add: newChange! !

!RefExRefactoring methodsFor: 'manipulating changes' stamp: 'rkrk 10/15/2007 23:32'!
changeNamed: changeName1 dependsOnChangeNamed: changeName2
 
	| change1 change2 |
	change1 := self  findChangeNamed: changeName1.
	change2 := self  findChangeNamed: changeName2.
	change1 dependsOn: change2 ! !

!RefExRefactoring methodsFor: 'accessing' stamp: 'rkrk 9/18/2007 16:05'!
changeSets
	^ changeSets! !

!RefExRefactoring methodsFor: 'accessing' stamp: 'rkrk 9/18/2007 16:05'!
changeSets: anObject
	changeSets := anObject! !

!RefExRefactoring methodsFor: 'finding' stamp: 'rkrk 10/15/2007 23:33'!
findChangeNamed: changeName
	
	^ self changeSets detect: [:each | each name = changeName]! !

!RefExRefactoring methodsFor: 'accessing' stamp: 'rkrk 9/18/2007 16:05'!
initialize
	super initialize.
	self 
		name: 'Unnamed Refactoring';
		description: 'No description yet.';
		changeSets: OrderedCollection new.! !

RefExEntry subclass: #RefExSmell
	instanceVariableNames: 'refactorings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Base'!

!RefExSmell methodsFor: 'accessing' stamp: 'rkrk 9/25/2007 01:13'!
addRefactoring: aRefExRefactoring

	self refactorings add: aRefExRefactoring ! !

!RefExSmell methodsFor: 'accessing' stamp: 'rkrk 9/18/2007 16:04'!
initialize
	super initialize.
	self
		name: 'Unnamed Smell'; 
		refactorings: OrderedCollection new.! !

!RefExSmell methodsFor: 'accessing' stamp: 'rkrk 9/18/2007 15:52'!
refactorings
	^ refactorings! !

!RefExSmell methodsFor: 'accessing' stamp: 'rkrk 9/18/2007 15:52'!
refactorings: anObject
	refactorings := anObject! !

RefExEntry subclass: #RefExTopic
	instanceVariableNames: 'refactorings smells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Base'!

!RefExTopic methodsFor: 'accessing' stamp: 'rkrk 9/18/2007 15:39'!
addRefactoring: aRefactoring
	refactorings add: aRefactoring! !

!RefExTopic methodsFor: 'accessing' stamp: 'rkrk 9/20/2007 02:19'!
addSmell: aRefExSmell
	smells add: aRefExSmell ! !

!RefExTopic methodsFor: 'finding' stamp: 'rkrk 10/15/2007 23:15'!
findRefactoringNamed: refactoringName

	^ self  refactorings detect: [:each | each name = refactoringName]! !

!RefExTopic methodsFor: 'accessing' stamp: 'rkrk 9/20/2007 02:42'!
initialize
	super initialize.
	self 
		refactorings: OrderedCollection new;
		smells: OrderedCollection new;
		name: 'Unnamed RefExTopic'.! !

!RefExTopic methodsFor: 'accessing' stamp: 'rkrk 9/25/2007 01:32'!
refactorings

	self flag: #TODO.
	^ self smells inject: refactorings copy into: [:allRefactorings :smell | |refsOfSmell|
		refsOfSmell := smell refactorings.
		allRefactorings addAll: (refsOfSmell difference: allRefactorings).
		allRefactorings]! !

!RefExTopic methodsFor: 'accessing' stamp: 'rkrk 9/18/2007 15:27'!
refactorings: anObject
	refactorings := anObject! !

!RefExTopic methodsFor: 'accessing' stamp: 'rkrk 9/20/2007 02:19'!
smells
	^ smells! !

!RefExTopic methodsFor: 'accessing' stamp: 'rkrk 9/20/2007 02:19'!
smells: anObject
	smells := anObject! !

OBNode subclass: #OBRefExChangesNode
	instanceVariableNames: 'change'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Browser-Nodes'!

!OBRefExChangesNode class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/24/2007 00:17'!
on: aRefExChange

	^ self new change: aRefExChange ! !

!OBRefExChangesNode methodsFor: 'accessing' stamp: 'rkrk 9/21/2007 14:02'!
change
	^ change! !

!OBRefExChangesNode methodsFor: 'accessing' stamp: 'rkrk 9/21/2007 14:02'!
change: anObject
	change := anObject! !

!OBRefExChangesNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/24/2007 01:39'!
changeSetFileName

	^ self change changeSetFileName ! !

!OBRefExChangesNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/25/2007 10:57'!
install

	self change loadChanges.! !

!OBRefExChangesNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/25/2007 00:28'!
isLoaded

	^ self change isLoaded! !

!OBRefExChangesNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/21/2007 14:02'!
name

	^ self change name! !

!OBRefExChangesNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/21/2007 14:02'!
text

	^ self change description! !

!OBRefExChangesNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/25/2007 10:57'!
uninstall

	self change unloadChangesAndRestoreBasedOn.! !

OBNode subclass: #OBRefExRefactoringNode
	instanceVariableNames: 'refactoring'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Browser-Nodes'!

!OBRefExRefactoringNode class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/21/2007 14:00'!
on: aRefactoring

	^self new refactoring: aRefactoring ! !

!OBRefExRefactoringNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/21/2007 14:03'!
changes
	^ self refactoring changeSets collect: [:each | OBRefExChangesNode on: each]! !

!OBRefExRefactoringNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/21/2007 14:00'!
name

	^ self refactoring name! !

!OBRefExRefactoringNode methodsFor: 'accessing' stamp: 'rkrk 9/21/2007 14:00'!
refactoring
	^ refactoring! !

!OBRefExRefactoringNode methodsFor: 'accessing' stamp: 'rkrk 9/21/2007 14:00'!
refactoring: anObject
	refactoring := anObject! !

!OBRefExRefactoringNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/21/2007 14:01'!
text

	^ self refactoring description! !

OBNode subclass: #OBRefExRootNode
	instanceVariableNames: 'topicCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Browser-Nodes'!

!OBRefExRootNode class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 02:04'!
on: aRefExTopicCollection

	^ self new topicCollection: aRefExTopicCollection ! !

!OBRefExRootNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/19/2007 15:33'!
text

	^ 'aRefExRootNode :-)'! !

!OBRefExRootNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 02:05'!
topicCollection

	^ topicCollection! !

!OBRefExRootNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 02:04'!
topicCollection: aRefExTopicCollection

	topicCollection := aRefExTopicCollection ! !

!OBRefExRootNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 16:06'!
topics
	^ self topicCollection collect: [:topic | OBRefExTopicNode on: topic]! !

OBNode subclass: #OBRefExSmellNode
	instanceVariableNames: 'smell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Browser-Nodes'!

!OBRefExSmellNode class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/25/2007 01:08'!
on: aRefExSmell

	^ self new smell: aRefExSmell ! !

!OBRefExSmellNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/25/2007 01:07'!
name

	^ self smell name! !

!OBRefExSmellNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/25/2007 01:10'!
refactorings
	^ self smell refactorings collect: [:each | OBRefExRefactoringNode on: each]! !

!OBRefExSmellNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/25/2007 01:07'!
smell

	^ smell! !

!OBRefExSmellNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/25/2007 01:08'!
smell: aRefExSmell 

	smell := aRefExSmell ! !

!OBRefExSmellNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/25/2007 01:10'!
text

	^ self smell description! !

OBNode subclass: #OBRefExTopicNode
	instanceVariableNames: 'topic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Browser-Nodes'!

!OBRefExTopicNode class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 04:14'!
on: aTopic

	^ self new topic: aTopic ! !

!OBRefExTopicNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/21/2007 13:57'!
name

	^ self topic name! !

!OBRefExTopicNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/25/2007 01:21'!
refactorings
	EinmalHalt halt.
	^ self topic refactorings collect: [:each | OBRefExRefactoringNode on: each].! !

!OBRefExTopicNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/25/2007 01:20'!
smells
	^ self topic smells collect: [:each | OBRefExSmellNode on: each].! !

!OBRefExTopicNode methodsFor: 'as yet unclassified' stamp: 'rkrk 9/27/2007 01:51'!
text

	^ self topic description asText allBold! !

!OBRefExTopicNode methodsFor: 'accessing' stamp: 'rkrk 9/20/2007 04:12'!
topic
	^ topic! !

!OBRefExTopicNode methodsFor: 'accessing' stamp: 'rkrk 9/20/2007 02:08'!
topic: anObject
	topic := anObject! !

OBBrowser subclass: #OBRefExBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Browser'!

!OBRefExBrowser class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 04:09'!
browseTopicCollection: aCollection

	^ self openRoot: (self defaultRootNode topicCollection: aCollection)! !

!OBRefExBrowser class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 16:09'!
defaultMetaNode
	| rootNode topicNode refactoringNode smellNode changesNode |
	rootNode := OBMetaNode named: 'root'.
	topicNode := OBMetaNode named: 'topic'.
	refactoringNode := OBMetaNode named: 'refactoring'.
	smellNode := OBMetaNode named: 'smell'.
	changesNode := OBMetaNode named: 'changes'.
	"--------------------------------------------"
	rootNode childAt: #topics put: topicNode.
	topicNode
		childAt: #refactorings labeled: 'refactorings' put: refactoringNode;
		childAt: #smells labeled: 'smells' put: smellNode;
		addFilter: OBModalFilter new.
	refactoringNode childAt: #changes put: changesNode.
	smellNode childAt: #refactorings put: refactoringNode.
	changesNode addFilter: OBRefExIconFilter new.
	^ rootNode! !

!OBRefExBrowser class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/19/2007 15:34'!
defaultRootNode
	^ RefExRootNode new! !

!OBRefExBrowser class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/19/2007 15:11'!
maxPanes

	^ 4! !

!OBRefExBrowser class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 04:11'!
minPanes

	^ 3! !

!OBRefExBrowser class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/27/2007 04:44'!
open

	^ self browseTopicCollection: RefExTopicCollection default! !

!OBRefExBrowser class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/19/2007 15:11'!
title

	^ 'RefExBrowser'! !

!OBRefExBrowser methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 20:54'!
cmdRefEx

	^ OBRefExCommand subclasses! !

OBCommand subclass: #OBRefExCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Browser-Commands'!

OBRefExCommand subclass: #OBRefExBrowseCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Browser-Commands'!

!OBRefExBrowseCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/24/2007 01:39'!
execute

	FileContentsBrowser browseFile: target changeSetFileName! !

!OBRefExBrowseCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/24/2007 01:33'!
isAButtonOnly
	^ true! !

!OBRefExBrowseCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/24/2007 01:33'!
isActive
	^ target isKindOf: OBRefExChangesNode! !

!OBRefExBrowseCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/24/2007 01:34'!
label
	^ 'browse'! !

!OBRefExBrowseCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/24/2007 01:33'!
wantsButton
	^ true! !

!OBRefExCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 14:06'!
addItemToMenu: aMenu
	self isAButtonOnly 
		ifFalse: [super addItemToMenu: aMenu]! !

!OBRefExCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 14:06'!
isAButtonOnly
	"Returns true if the command must not appear in context menus"
	^ false! !

!OBRefExCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2007 14:06'!
refreshRequired
	requestor announce: OBRefreshRequired! !

OBRefExCommand subclass: #OBRefExLoadCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Browser-Commands'!

!OBRefExLoadCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/25/2007 10:55'!
execute

	target install.
	requestor announce: (OBNodeChanged node: target)! !

!OBRefExLoadCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/24/2007 02:16'!
isAButtonOnly
	^ true! !

!OBRefExLoadCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/24/2007 23:56'!
isActive
	^ (target isKindOf: OBRefExChangesNode) and: [target isLoaded not]! !

!OBRefExLoadCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/25/2007 00:47'!
label
	^ 'load'! !

!OBRefExLoadCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/24/2007 02:16'!
wantsButton
	^ true! !

OBRefExCommand subclass: #OBRefExUnloadCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Browser-Commands'!

!OBRefExUnloadCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/25/2007 10:56'!
execute

	target uninstall.
	requestor announce: (OBNodeChanged node: target)! !

!OBRefExUnloadCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/24/2007 02:40'!
isAButtonOnly
	^ true! !

!OBRefExUnloadCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/24/2007 23:56'!
isActive
	^ (target isKindOf: OBRefExChangesNode) and: [target isLoaded]! !

!OBRefExUnloadCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/25/2007 00:47'!
label
	^ 'unload'! !

!OBRefExUnloadCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 9/24/2007 02:40'!
wantsButton
	^ true! !

TestCase subclass: #RefExBaseAcceptanceTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Base-Tests'!

!RefExBaseAcceptanceTest methodsFor: 'as yet unclassified' stamp: 'rkrk 9/21/2007 14:25'!
testDescriptionOfRefShouldNotAffectDesritpionOfTopic

	| topic ref |
	topic := RefExTopic named: 'aTopic'.
	topic description: 'topicDescription'.
	ref := RefExRefactoring named: 'aRef'.
	ref description: 'refDescritpion'.
	self assert: ref description ~= topic description.! !

TestCase subclass: #RefExChangeSetLoaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Base-Tests'!

!RefExChangeSetLoaderTest methodsFor: 'tests' stamp: 'rkrk 9/19/2007 03:21'!
acceptanceTestReallyLoadChangeSet
	| sut changeSetName changeSetFileName getChangeSetBlock |
	self flag: #refactor.
	changeSetName := 'einChangeSet'.
	getChangeSetBlock := [ChangeSet named: changeSetName].
	changeSetFileName := changeSetName , '.1.cs'.
	(FileDirectory default newFileNamed: changeSetFileName) close.
	sut := RefExChangeSetLoader 
		for: changeSetFileName
		withStreamType: FileStream
		andService: ChangeSet serviceFileIntoNewChangeSet.
	
	[sut loadChangeSet.
	self assert: getChangeSetBlock value notNil] 
			ensure: 
				[ChangeSet removeChangeSet: getChangeSetBlock value.
				FileDirectory default deleteFileNamed: changeSetFileName]! !

!RefExChangeSetLoaderTest methodsFor: 'tests' stamp: 'rkrk 9/24/2007 23:29'!
testAlreadyLoaded

	| sut |
	sut := RefExChangeSetLoader
		for: 'NameOfNonExisitingChangeSet.1.st' 
		withStreamType: FileStream
		andService: nil. "Service not needed for this test."
	self should: [sut loadChangeSet] raise: Error.! !

!RefExChangeSetLoaderTest methodsFor: 'tests' stamp: 'rkrk 9/19/2007 02:52'!
testChangeSetNameFromFileName
	| sut changeSetName changeSetFileName |
	changeSetName := 'einChangeSet'.
	changeSetFileName := 'einChangeSet.1.cs'.
	sut := RefExChangeSetLoader new
		fileName: changeSetFileName;
		yourself.
	self assert: sut changeSetNameFromFileName equals: changeSetName.! !

!RefExChangeSetLoaderTest methodsFor: 'tests' stamp: 'rkrk 9/23/2007 19:47'!
testLoadChangeSet

	| sut changeSetName changeSetFileName mockStream |
	changeSetName := 'einChangeSet'.
	changeSetFileName := changeSetName , '.1.cs'.
	mockStream := Mock new.
	mockStream acceptAllMessages.
	(mockStream expect: #isAFileNamed:) 
		with: changeSetFileName;
		returns: true.
	(mockStream expect: #fileNamed:do:) 
		with: changeSetFileName; withAnyArgs.
	sut := RefExChangeSetLoader
		for: changeSetFileName
		withStreamType: mockStream proxy
		andService: nil. "not needed"
	sut loadChangeSet.
	mockStream verify.
	
	"[:mockStream |
		sut := RefExChangeSetLoader
			for: changeSetFileName
			withStreamType: mockStream 
			andService: nil. ""not needed""
		sut loadChangeSet.
	] should strictly satisfy: [:mockStream |
		(mockStream isAFileNamed: changeSetFileName) willReturn: true.
		mockStream fileNamed: changeSetFileName do: Any.]"! !

!RefExChangeSetLoaderTest methodsFor: 'tests' stamp: 'rkrk 9/19/2007 03:19'!
testLoadChangeSetWithIncorrectNameShouldFail

	| sut |
	sut := RefExChangeSetLoader 
		withStreamType: FileStream
		andService: nil. "Service not needed for this test."
	self should: [sut loadChangeSetFromFileNamed: 'NameOfNonExisitingChangeSet.22.cs'] raise: Error.! !

!RefExChangeSetLoaderTest methodsFor: 'tests' stamp: 'rkrk 10/15/2007 20:03'!
testShouldRecognizeIfLoadedIntoSystem
	| sut changeSetName |
	changeSetName := 'einChangeSet'.
	sut := RefExChangeSetLoader 
				for: changeSetName , '.1.cs'
				withStreamType: FileStream
				andService: ChangeSet serviceFileIntoNewChangeSet.
	[
		self deny: sut isLoaded.
		ChangeSet assuredChangeSetNamed: changeSetName.
		self assert: sut isLoaded.
	] ensure: [
		ChangeSet removeChangeSet: (ChangeSet named: changeSetName).]! !

TestCase subclass: #RefExChangeTest
	instanceVariableNames: 'mock sut mockOfChangeProxy mockOfChange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Base-Tests'!

!RefExChangeTest methodsFor: 'as yet unclassified' stamp: 'rkrk 9/25/2007 09:44'!
setUp
	super setUp.
	mockOfChangeProxy := Mock newForClass: RefExChangeSetLoader.
	mockOfChange := Mock newForClass: RefExChange.
	sut := RefExChange named: 'aTestRefExChange'! !

!RefExChangeTest methodsFor: 'tests' stamp: 'rkrk 9/25/2007 09:58'!
testChangeKnowsHisBasedOnChanges

	| anotherChange |
	self assert: sut basedOnChanges isEmpty.

	anotherChange := (RefExChange named: 'anotherTestRefExChange').
	sut dependsOn: anotherChange.

	self assert: sut basedOnChanges includes: anotherChange! !

!RefExChangeTest methodsFor: 'tests' stamp: 'rkrk 9/25/2007 09:54'!
testDependsOnShouldAddDependentForOtherChange
	"The sut depends on the mock which is the role of another RefExChange. 
	In this case the mock should know the sut as a dependent."

	(mockOfChange expect: #addAsDependent:) with: sut.
	sut dependsOn: mockOfChange proxy.
	mockOfChange verify! !

!RefExChangeTest methodsFor: 'tests' stamp: 'rkrk 9/25/2007 09:59'!
testLoadBasedOnChange
	(mockOfChange stub: #addAsDependent:) withAnyArgs.
	(mockOfChange stub: #isLoaded) returns: false.
	mockOfChange expect: #loadChanges.
	
	sut dependsOn: mockOfChange proxy.
	sut loadChanges.
	
	mockOfChange verify! !

!RefExChangeTest methodsFor: 'tests' stamp: 'rkrk 9/25/2007 09:47'!
testLoadChangesShouldInvokeLoadingOfChangeSetProxy
	
	mockOfChangeProxy expect: #loadChangeSet.
	sut
		changeSetProxy: mockOfChangeProxy proxy;
		loadChanges.
	mockOfChangeProxy verify! !

!RefExChangeTest methodsFor: 'tests' stamp: 'rkrk 9/25/2007 09:49'!
testUnloadChangeShouldInvokeDependend

	mockOfChangeProxy expect: #loadChangeSet.

	sut 
		changeSetProxy: mockOfChangeProxy proxy;
		loadChanges.
	mockOfChange verify.! !

!RefExChangeTest methodsFor: 'tests' stamp: 'rkrk 10/15/2007 20:10'!
testUnloadChangeShouldUnloadDependend

	"(mockOfChange stub: #isLoaded) returns: true.
	mockOfChange expect: #unloadChanges.
	
	sut addAsDependent: mockOfChange proxy.
	sut unloadChanges.
	
	mockOfChange verify"
	[:changeMock | 
		sut addAsDependent: changeMock. 
		sut unloadChanges.
	] should strictly satisfy: [:changeMock | 
		"self halt." 
		(changeMock isLoaded) willReturn: true. 
		changeMock unloadChanges
	].
	"	
	changeDependsOnSut:= RefExChange named: 'dependOnSut'.
	
	changeDependsOnSut dependsOn: sut.
	
	sut unloadChanges.
	self assert: changeDependsOnSut isLoaded not"! !

TestCase subclass: #RefExRefactoringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Base-Tests'!

!RefExRefactoringTest methodsFor: 'as yet unclassified' stamp: 'rkrk 10/15/2007 23:29'!
testAddChangeDependence

	| sut changeName1 changeName2 change1 change2 |
	sut := RefExRefactoring new.
	changeName1 := 'aChange'.
	changeName2 := 'anotherChange'.

	sut 
		addChangeNamed: changeName1
		withChangeFileName: '';
		addChangeNamed: changeName2
		withChangeFileName: ''.
		
	sut 
		changeNamed: changeName1 
		dependsOnChangeNamed: changeName2.
	
	change1 := sut findChangeNamed: changeName1.
	change2 := sut findChangeNamed: changeName2.
	self assert: change1 basedOnChanges includes: change2.! !

!RefExRefactoringTest methodsFor: 'as yet unclassified' stamp: 'rkrk 10/15/2007 23:01'!
testAddChangeNamed

	| sut changeName changeFileName result |
	sut := RefExRefactoring new.
	changeName := 'aChange'.
	changeFileName := 'someChangeFile.1.cs'.
	sut 
		addChangeNamed: changeName
		withChangeFileName: changeFileName.
		
	self assert: sut changeSets size = 1.
	result := sut changeSets first.
	self assert: result name = changeName.
	self assert: result changeSetProxy fileName = changeFileName.! !

TestCase subclass: #RefExTopicCollectionTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Base-Tests'!

!RefExTopicCollectionTest methodsFor: 'as yet unclassified' stamp: 'rkrk 10/15/2007 23:23'!
testAddChange

	| topicName refactoringName changeName changeFileName |
	sut := RefExTopicCollection new.
	
	topicName := 'someTopic'.
	refactoringName := 'someRefactoring'.
	changeName := 'aChange'.
	changeFileName := 'someChangeFile.1.cs'.
	sut 
		inTopicNamed: topicName 
		addRefactoringNamed: refactoringName
		withDescription: ''.
	sut 
		inRefactoringNamed: refactoringName
		addChangeNamed: changeName
		withChangeFileName: changeFileName.
		
	self assert: false. "some test should be here..."! !

!RefExTopicCollectionTest methodsFor: 'as yet unclassified' stamp: 'rkrk 10/15/2007 21:40'!
testAddRefactoringInExistingTopic

	| topicName refactoringName refactoringDescription |
	sut := RefExTopicCollection new.
	
	topicName := 'someTopic'.
	refactoringName := 'someRefactoring'.
	refactoringDescription := 'blablabla'.
	[:mockTopic | 
		sut add: mockTopic.
		sut 
			inTopicNamed: topicName 
			addRefactoringNamed: refactoringName
			withDescription: refactoringDescription
	] should strictly satisfy: [: mockTopic |
		mockTopic name willReturn: topicName.
		mockTopic addRefactoring: Any
	]! !

!RefExTopicCollectionTest methodsFor: 'as yet unclassified' stamp: 'rkrk 10/15/2007 22:47'!
testAddRefactoringInNonExistingTopic

	| topicName refactoringName refactoringDescription |
	sut := RefExTopicCollection new.
	
	topicName := 'someTopic'.
	refactoringName := 'someRefactoring'.
	refactoringDescription := 'blablabla'.
	sut	
		inTopicNamed: topicName 
		addRefactoringNamed: refactoringName
		withDescription: refactoringDescription.
	self assert: (sut anySatisfy: [:each | 
		each name = topicName & (each refactorings anySatisfy: 
			[:refactoring |
				refactoring name = refactoringName & 
				(refactoring description = refactoringDescription) ])])! !

!RefExTopicCollectionTest methodsFor: 'as yet unclassified' stamp: 'rkrk 10/15/2007 19:57'!
testAddTopic

	| topicName topicDecription topic |
	sut := RefExTopicCollection new.
	topicName := 'someTopic'.
	topicDecription := 'someDescription'.
	sut addTopicNamed: topicName withDescription: topicDecription.
	
	self assert: sut size = 1.
	topic := sut first.
	self assert: topic name = topicName.
	self assert: topic description = topicDecription.! !

TestCase subclass: #RefExTopicTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefEx-Base-Tests'!

!RefExTopicTest methodsFor: 'tests' stamp: 'rkrk 9/18/2007 15:21'!
setUp

	sut := RefExTopic new! !

!RefExTopicTest methodsFor: 'tests' stamp: 'rkrk 9/18/2007 15:43'!
testAddRefactorings
	| aRefactoring |
	self assert: sut refactorings isEmpty.
	aRefactoring := RefExRefactoring new.
	sut addRefactoring: aRefactoring.
	self assert: (sut refactorings includes: aRefactoring)! !

!RefExTopicTest methodsFor: 'tests' stamp: 'rkrk 9/23/2007 15:10'!
testRefactoringsIncludeNormalAndSmellRefactorings


	| mockSmell mockRefactoring |
	mockSmell := Mock new.
	mockRefactoring := Mock new.
	
	(mockSmell stub: #refactorings) returns: (OrderedCollection with: mockRefactoring).
	sut addSmell: mockSmell proxy.
	
	self assert: sut refactorings includes: mockRefactoring.! !

!RefExTopicTest methodsFor: 'tests' stamp: 'rkrk 9/18/2007 16:02'!
testTopicName

	| topicName |
	topicName := 'TopicForTesting'.
	sut name: topicName.
	self assert: sut name = topicName.! !
